/*
 * This file is generated by gdbus-codegen, do not modify it.
 *
 * The license of this code is the same as for the D-Bus interface description
 * it was derived from. Note that it links to GLib, so must comply with the
 * LGPL linking clauses.
 */

#ifndef __XDP_DBUS_H__
#define __XDP_DBUS_H__

#include <gio/gio.h>

G_BEGIN_DECLS


/* ------------------------------------------------------------------------ */
/* Declarations for org.freedesktop.portal.OpenURI */

#define GXDP_TYPE_OPEN_URI (gxdp_open_uri_get_type ())
#define GXDP_OPEN_URI(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), GXDP_TYPE_OPEN_URI, GXdpOpenURI))
#define GXDP_IS_OPEN_URI(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), GXDP_TYPE_OPEN_URI))
#define GXDP_OPEN_URI_GET_IFACE(o) (G_TYPE_INSTANCE_GET_INTERFACE ((o), GXDP_TYPE_OPEN_URI, GXdpOpenURIIface))

struct _GXdpOpenURI;
typedef struct _GXdpOpenURI GXdpOpenURI;
typedef struct _GXdpOpenURIIface GXdpOpenURIIface;

struct _GXdpOpenURIIface
{
  GTypeInterface parent_iface;


  gboolean (*handle_open_directory) (
    GXdpOpenURI *object,
    GDBusMethodInvocation *invocation,
    GUnixFDList *fd_list,
    const gchar *arg_parent_window,
    GVariant *arg_fd,
    GVariant *arg_options);

  gboolean (*handle_open_file) (
    GXdpOpenURI *object,
    GDBusMethodInvocation *invocation,
    GUnixFDList *fd_list,
    const gchar *arg_parent_window,
    GVariant *arg_fd,
    GVariant *arg_options);

  gboolean (*handle_open_uri) (
    GXdpOpenURI *object,
    GDBusMethodInvocation *invocation,
    const gchar *arg_parent_window,
    const gchar *arg_uri,
    GVariant *arg_options);

  guint  (*get_version) (GXdpOpenURI *object);

};

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GXdpOpenURI, g_object_unref)
#endif

GType gxdp_open_uri_get_type (void) G_GNUC_CONST;

GDBusInterfaceInfo *gxdp_open_uri_interface_info (void);
guint gxdp_open_uri_override_properties (GObjectClass *klass, guint property_id_begin);


/* D-Bus method call completion functions: */
void gxdp_open_uri_complete_open_uri (
    GXdpOpenURI *object,
    GDBusMethodInvocation *invocation,
    const gchar *handle);

void gxdp_open_uri_complete_open_file (
    GXdpOpenURI *object,
    GDBusMethodInvocation *invocation,
    GUnixFDList *fd_list,
    const gchar *handle);

void gxdp_open_uri_complete_open_directory (
    GXdpOpenURI *object,
    GDBusMethodInvocation *invocation,
    GUnixFDList *fd_list,
    const gchar *handle);



/* D-Bus method calls: */
void gxdp_open_uri_call_open_uri (
    GXdpOpenURI *proxy,
    const gchar *arg_parent_window,
    const gchar *arg_uri,
    GVariant *arg_options,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean gxdp_open_uri_call_open_uri_finish (
    GXdpOpenURI *proxy,
    gchar **out_handle,
    GAsyncResult *res,
    GError **error);

gboolean gxdp_open_uri_call_open_uri_sync (
    GXdpOpenURI *proxy,
    const gchar *arg_parent_window,
    const gchar *arg_uri,
    GVariant *arg_options,
    gchar **out_handle,
    GCancellable *cancellable,
    GError **error);

void gxdp_open_uri_call_open_file (
    GXdpOpenURI *proxy,
    const gchar *arg_parent_window,
    GVariant *arg_fd,
    GVariant *arg_options,
    GUnixFDList *fd_list,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean gxdp_open_uri_call_open_file_finish (
    GXdpOpenURI *proxy,
    gchar **out_handle,
    GUnixFDList **out_fd_list,
    GAsyncResult *res,
    GError **error);

gboolean gxdp_open_uri_call_open_file_sync (
    GXdpOpenURI *proxy,
    const gchar *arg_parent_window,
    GVariant *arg_fd,
    GVariant *arg_options,
    GUnixFDList  *fd_list,
    gchar **out_handle,
    GUnixFDList **out_fd_list,
    GCancellable *cancellable,
    GError **error);

void gxdp_open_uri_call_open_directory (
    GXdpOpenURI *proxy,
    const gchar *arg_parent_window,
    GVariant *arg_fd,
    GVariant *arg_options,
    GUnixFDList *fd_list,
    GCancellable *cancellable,
    GAsyncReadyCallback callback,
    gpointer user_data);

gboolean gxdp_open_uri_call_open_directory_finish (
    GXdpOpenURI *proxy,
    gchar **out_handle,
    GUnixFDList **out_fd_list,
    GAsyncResult *res,
    GError **error);

gboolean gxdp_open_uri_call_open_directory_sync (
    GXdpOpenURI *proxy,
    const gchar *arg_parent_window,
    GVariant *arg_fd,
    GVariant *arg_options,
    GUnixFDList  *fd_list,
    gchar **out_handle,
    GUnixFDList **out_fd_list,
    GCancellable *cancellable,
    GError **error);



/* D-Bus property accessors: */
guint gxdp_open_uri_get_version (GXdpOpenURI *object);
void gxdp_open_uri_set_version (GXdpOpenURI *object, guint value);


/* ---- */

#define GXDP_TYPE_OPEN_URI_PROXY (gxdp_open_uri_proxy_get_type ())
#define GXDP_OPEN_URI_PROXY(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), GXDP_TYPE_OPEN_URI_PROXY, GXdpOpenURIProxy))
#define GXDP_OPEN_URI_PROXY_CLASS(k) (G_TYPE_CHECK_CLASS_CAST ((k), GXDP_TYPE_OPEN_URI_PROXY, GXdpOpenURIProxyClass))
#define GXDP_OPEN_URI_PROXY_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), GXDP_TYPE_OPEN_URI_PROXY, GXdpOpenURIProxyClass))
#define GXDP_IS_OPEN_URI_PROXY(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), GXDP_TYPE_OPEN_URI_PROXY))
#define GXDP_IS_OPEN_URI_PROXY_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), GXDP_TYPE_OPEN_URI_PROXY))

typedef struct _GXdpOpenURIProxy GXdpOpenURIProxy;
typedef struct _GXdpOpenURIProxyClass GXdpOpenURIProxyClass;
typedef struct _GXdpOpenURIProxyPrivate GXdpOpenURIProxyPrivate;

struct _GXdpOpenURIProxy
{
  /*< private >*/
  GDBusProxy parent_instance;
  GXdpOpenURIProxyPrivate *priv;
};

struct _GXdpOpenURIProxyClass
{
  GDBusProxyClass parent_class;
};

GType gxdp_open_uri_proxy_get_type (void) G_GNUC_CONST;

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GXdpOpenURIProxy, g_object_unref)
#endif

void gxdp_open_uri_proxy_new (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data);
GXdpOpenURI *gxdp_open_uri_proxy_new_finish (
    GAsyncResult        *res,
    GError             **error);
GXdpOpenURI *gxdp_open_uri_proxy_new_sync (
    GDBusConnection     *connection,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error);

void gxdp_open_uri_proxy_new_for_bus (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GAsyncReadyCallback  callback,
    gpointer             user_data);
GXdpOpenURI *gxdp_open_uri_proxy_new_for_bus_finish (
    GAsyncResult        *res,
    GError             **error);
GXdpOpenURI *gxdp_open_uri_proxy_new_for_bus_sync (
    GBusType             bus_type,
    GDBusProxyFlags      flags,
    const gchar         *name,
    const gchar         *object_path,
    GCancellable        *cancellable,
    GError             **error);


/* ---- */

#define GXDP_TYPE_OPEN_URI_SKELETON (gxdp_open_uri_skeleton_get_type ())
#define GXDP_OPEN_URI_SKELETON(o) (G_TYPE_CHECK_INSTANCE_CAST ((o), GXDP_TYPE_OPEN_URI_SKELETON, GXdpOpenURISkeleton))
#define GXDP_OPEN_URI_SKELETON_CLASS(k) (G_TYPE_CHECK_CLASS_CAST ((k), GXDP_TYPE_OPEN_URI_SKELETON, GXdpOpenURISkeletonClass))
#define GXDP_OPEN_URI_SKELETON_GET_CLASS(o) (G_TYPE_INSTANCE_GET_CLASS ((o), GXDP_TYPE_OPEN_URI_SKELETON, GXdpOpenURISkeletonClass))
#define GXDP_IS_OPEN_URI_SKELETON(o) (G_TYPE_CHECK_INSTANCE_TYPE ((o), GXDP_TYPE_OPEN_URI_SKELETON))
#define GXDP_IS_OPEN_URI_SKELETON_CLASS(k) (G_TYPE_CHECK_CLASS_TYPE ((k), GXDP_TYPE_OPEN_URI_SKELETON))

typedef struct _GXdpOpenURISkeleton GXdpOpenURISkeleton;
typedef struct _GXdpOpenURISkeletonClass GXdpOpenURISkeletonClass;
typedef struct _GXdpOpenURISkeletonPrivate GXdpOpenURISkeletonPrivate;

struct _GXdpOpenURISkeleton
{
  /*< private >*/
  GDBusInterfaceSkeleton parent_instance;
  GXdpOpenURISkeletonPrivate *priv;
};

struct _GXdpOpenURISkeletonClass
{
  GDBusInterfaceSkeletonClass parent_class;
};

GType gxdp_open_uri_skeleton_get_type (void) G_GNUC_CONST;

#if GLIB_CHECK_VERSION(2, 44, 0)
G_DEFINE_AUTOPTR_CLEANUP_FUNC (GXdpOpenURISkeleton, g_object_unref)
#endif

GXdpOpenURI *gxdp_open_uri_skeleton_new (void);


G_END_DECLS

#endif /* __XDP_DBUS_H__ */
